]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame - rpm.macros
- I don't know how did you manage to get this to work without dist_kernel
[packages/rpm-build-macros.git] / rpm.macros
CommitLineData
397b586d 1# $Revision$, $Date$
415f4a1a 2# PLD Linux rpm macros
d54662bf 3
e05017c1 4%epoch 0
3241033b 5%x8664 x86_64 amd64 ia32e
9c404149 6
ba1fdedc 7# kernel compiler
345d14e5 8%kgcc %{__cc}
d2e1bc22 9%kgcc_package gcc
ba1fdedc 10
46763914
ER
11# compiler version
12%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion || echo ERROR)}%cc_version
de629430 13%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion || echo ERROR)}%cxx_version
46763914 14
36eccf0d
ER
15%__rm /bin/rm --interactive=never
16
33040789 17# Build system path macros.
18#
bddadece
JB
19%__autoconf autoconf %{?debug:-Wall}
20%__automake automake -a -c -f --foreign
f93109a0 21%__autopoint autopoint --force
22
83094b62 23%__gettextize { \
8a995cff 24 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
3241033b 25 gettextize --copy --force --no-changelog; \
97589b6e 26 else \
3241033b 27 gettextize --copy --force --no-changelog --intl; \
8a995cff
JB
28 fi; \
29 if [ ! -f po/Makevars ]; then \
3241033b 30 cp -f po/Makevars{.template,}; \
8a995cff 31 fi; \
8a995cff 32}
f93109a0 33
34%__glib_gettextize glib-gettextize --copy --force
35%__gnome_doc_common gnome-doc-common --copy
fb59e475 36%__gnome_doc_prepare gnome-doc-prepare --copy --force
f93109a0 37%__gtkdocize gtkdocize --copy
38%__intltoolize intltoolize --copy --force
c26f1b59 39%__libtoolize libtoolize --copy --force --install
33040789 40
384e1b2b 41# Path to top of build area.
f5f7156a 42%_topdir %{expand:%%global _topdir %(test -d ../SPECS -a -d ../SOURCES && (cd ..; pwd) || echo $HOME/rpm)}%_topdir
384e1b2b 43
81e450f7
ER
44# The number of cvs changelog entries kept when building package.
45%_buildchangelogtruncate 20
46
6a5eda77 47%dependencytracking %{nil}
3241033b 48
e5da9169
ER
49# Relations between package names that cause dependency loops
50# with legacy packages that cannot be fixed. Relations are
51# specified as
52# p>q
53# where package p has a Requires: on something that package q Provides:
54#
55# XXX Note: that there cannot be any whitespace within the string "p>q",
56# and that both p and q are package names (i.e. no version/release).
57%_dependency_whiteout %{nil}
58
7bf0526c 59%_smp_mflags %([ -z "$RPM_BUILD_NCPUS" ] \\\
c9d403e1 60 && RPM_BUILD_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); \\\
19f42054 61 [ "$RPM_BUILD_NCPUS" -gt 1 ] && echo "-j$(($RPM_BUILD_NCPUS * 2))")
810fa5c4 62
63#-----------------------------------------------------------------
64#
65# (re)definition of %{rpm*flags} with %filterout_* support
b5e977c5
ER
66# BuildRequires: awk
67# BuildRequires: rpmbuild(macros) >= 1.315
810fa5c4 68#
69# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
09a90176 70# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
71# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
98e7f050 72# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
09a90176 73# %rpmldflags = %optldflags - %filterout_ld
810fa5c4 74#
75# Regular expressions are supported, but to avoid some character be treated
76# as regular expression it must be escaped twice.
77
78%filter_out \
7b6f1112 79 for (i = 1; i in I; i++) { A=0; \
810fa5c4 80 for (f in F) { \
81 if (I[i] ~ "^" F[f] "$") A=1; \
82 }; \
83 if (!A) printf(I[i] FS); \
84 }
85
86%rpmcflags %(awk 'BEGIN {
87 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
09a90176 88 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
810fa5c4 89 %{filter_out}
90}')
91
92%rpmcxxflags %(awk 'BEGIN {
09a90176 93 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
94 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
810fa5c4 95 %{filter_out}
96}')
97
98e7f050
AM
98%rpmcppflags %(awk 'BEGIN {
99 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
100 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
101 %{filter_out}
102}')
103
810fa5c4 104%rpmldflags %(awk 'BEGIN {
c05a0741 105 split("%{?optldflags}",I);
810fa5c4 106 split("%{?filterout_ld}",F)
107 %{filter_out}
108}')
109
25f52d1a 110# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
111# but, don't use it, better use gcc as linker
112%ld_rpmldflags %(awk 'BEGIN {
113 split("%{rpmldflags}",F);
114 for (f in F) {
115 s = F[f];
116 if (s ~ /^-Wl,/) {
117 s = substr(s,5);
118 gsub(/,/," ",s);
119 };
120 printf(s FS);
121 };
122}')
123
9c404149 124#-----------------------------------------------------------------
9f4ce098 125%configure2_13 { \
9c404149
AM
126 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
127 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
128 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
f4cc8832 129 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
9c404149 130 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
e9d801f4 131 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
98e7f050 132 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
8983c4c4
AM
133 %{?__cc:CC="%{__cc}" ; export CC ; } \
134 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
8f74418b 135 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
2a7cfd3f 136 --host=%{_target_platform} \
9c404149
AM
137 --prefix=%{_prefix} \
138 --exec-prefix=%{_exec_prefix} \
139 --bindir=%{_bindir} \
140 --sbindir=%{_sbindir} \
141 --sysconfdir=%{_sysconfdir} \
142 --datadir=%{_datadir} \
143 --includedir=%{_includedir} \
144 --libdir=%{_libdir} \
145 --libexecdir=%{_libexecdir} \
146 --localstatedir=%{_localstatedir} \
147 --sharedstatedir=%{_sharedstatedir} \
148 --mandir=%{_mandir} \
149 --infodir=%{_infodir} \
b6c5da52 150 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 151 %{dependencytracking} \
9c404149
AM
152}
153
89f4ca1f 154%__cmake /usr/bin/cmake
39b9534b
ER
155%cmake { \
156CC="%{__cc}" \
157CXX="%{__cxx}" \
158CFLAGS="%{rpmcflags}" \
159CXXFLAGS="%{rpmcxxflags}" \
12513dc1 160LDFLAGS="%{rpmldflags}" \
89f4ca1f
ER
161%{__cmake} \
162}
163
164# override __scons to add -j4 in your ~/.rpmmacros for parallel make
165%__scons /usr/bin/scons
166%scons { \
167%{__scons} \
5c76736d
ER
168 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
169 CFLAGS="${CFLAGS:-%rpmcflags}" \
170 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
171 FFLAGS="${FFLAGS:-%rpmcflags}" \
98e7f050 172 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
5c76736d
ER
173 %{?__cc:CC="%{__cc}"} \
174 %{?__cxx:CXX="%{__cxx}"} \
175 libsuffix=%{_lib} \
176 prefix=%{_prefix} \
39b9534b
ER
177}
178
6339d32d 179# waf. see waf.spec
89f4ca1f 180# override __waf to add -j4 in your ~/.rpmmacros for parallel make
6339d32d
ER
181%__waf /usr/bin/waf
182%waf { \
6339d32d
ER
183CC="%{__cc}" \
184CXX="%{__cxx}" \
9e244007 185CPP="%{__cpp}" \
6339d32d
ER
186CFLAGS="%{rpmcflags}" \
187CXXFLAGS="%{rpmcxxflags}" \
188%{__waf} \
6339d32d
ER
189}
190
4a6b0d54 191#----------------------------------------------------------------
9bacbb5b 192#%configure_cache 0
fe6c4bdd 193%configure_cache_file %{buildroot}.configure.cache
73f832b3 194
57f4166d 195%configure {./configure \
4a6b0d54
AF
196 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
197 CFLAGS="${CFLAGS:-%rpmcflags}" \
f4cc8832 198 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
4a6b0d54 199 FFLAGS="${FFLAGS:-%rpmcflags}" \
e9d801f4 200 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
98e7f050 201 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
8983c4c4
AM
202 %{?__cc:CC="%{__cc}"} \
203 %{?__cxx:CXX="%{__cxx}"} \
8e4cb85a 204 --host=%{_target_platform} \
4a6b0d54
AF
205 --build=%{_target_platform} \
206 --prefix=%{_prefix} \
207 --exec-prefix=%{_exec_prefix} \
208 --bindir=%{_bindir} \
209 --sbindir=%{_sbindir} \
210 --sysconfdir=%{_sysconfdir} \
211 --datadir=%{_datadir} \
212 --includedir=%{_includedir} \
213 --libdir=%{_libdir} \
214 --libexecdir=%{_libexecdir} \
215 --localstatedir=%{_localstatedir} \
216 --sharedstatedir=%{_sharedstatedir} \
217 --mandir=%{_mandir} \
218 --infodir=%{_infodir} \
b6c5da52 219 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 220 %{dependencytracking} \
9bacbb5b 221 %{?configure_cache:--cache-file=%{configure_cache_file}} \
4a6b0d54
AF
222}
223
b3b1397b
ER
224# overload to insert debuginfo package
225%prep \
226%if 0%{?_enable_debug_packages}\
227%{debug_package}\
228%endif\
229%%prep\
230%{nil}
231
9c404149 232# Location of autoconf macros
7f0f4a79 233%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir || echo ERROR)}%_aclocaldir
9c404149 234
e2804f99 235# Location of omf files
7f0f4a79 236%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
e2804f99 237
e987a186 238# Location of pkgconfig files
9a4e877a 239%_pkgconfigdir /usr/%{_lib}/pkgconfig
36219c36
JB
240# noarch pkgconfig files
241%_npkgconfigdir /usr/share/pkgconfig
e987a186 242
486b0b5f 243# Location of desktop files
244%_desktopdir /usr/share/applications
86dff2d0 245%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
486b0b5f 246
481463e9 247# Location of pixmaps for applnk/desktop files
e1f0a822 248%_pixmapsdir /usr/share/pixmaps
9c404149 249
481463e9 250# Location of themable icons for applnk/desktop files
b36c8e2a 251%_iconsdir /usr/share/icons
252
e987a186
JB
253# Location of fonts directories
254%_fontsdir /usr/share/fonts
255
b3282f3f 256# Location of Gtk and associated libraries documentation
fe6c4bdd 257%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
b3282f3f 258
fc4d7771 259# Location of KDE documentation
fe6c4bdd 260%_kdedocdir %{_defaultdocdir}/kde/HTML
fc4d7771 261
5869828c 262# unsermake script
263%__unsermake /usr/share/unsermake/unsermake
264
9c404149
AM
265# Current date
266%date %(LC_ALL="C" date +"%a %b %d %Y")
267
9c404149
AM
268# Example files, programs, scripts...
269%_examplesdir /usr/src/examples
270
c8f7e820 271# Alternative kernel type/version
261729d9 272%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
c8f7e820 273
8377d27d 274# The directory holding Linux kernel sources
261729d9 275%_kernelsrcdir /usr/src/linux%{_alt_kernel}
8377d27d 276
9c404149 277# If non-empty "debug" macro defined, add "dbg" suffix to release number
8f74418b 278%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
9c404149 279
8f74418b 280# Requires name = version-release
d514eecd 281%requires_releq() %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}-%{R}\\n' | grep -v 'is not')
8bf3719d 282
f5f7156a
ER
283%releq_kernel %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
284%releq_kernel_up %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
285%releq_kernel_smp() %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
730239f9
ER
286%requires_releq_kernel(s:) Requires%{-s:(%{-s*})}: %releq_kernel
287%requires_releq_kernel_up(s:) Requires%{-s:(%{-s*})}: %releq_kernel_up
288%requires_releq_kernel_smp(s:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
8bf3719d 289
d514eecd
ER
290# XXX: why epoch 0 is stripped?
291%requires_eq() %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}\\n' | sed -e 's/ 0:/ /' | grep -v 'is not')
292%requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}' %2 | grep -v "is not")
01a9f990 293
c94807f3 294%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
b9d5d440 295
296# kernel version-release handling
95125403
ER
297%__kernel_ver %{expand:%%global __kernel_ver %( \\
298 Z=$(awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
299 Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
300 echo ${Z:-ERROR}; \\
1a7d3518 301)}%__kernel_ver
95125403 302
c94807f3
ER
303%__kernel_rel %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
304%__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
305%_kernel_ver %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
306%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
87be1cf0 307
6262f001
ER
308# `uname -r` to be used in @release field
309%_kernel_vermagic %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
310
e00dd7f6 311# sgml macros
3241033b
ER
312%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
313%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
314%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
315%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
316%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
317%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
e00dd7f6 318%docbook_sgmlcat_fix() { for l in \
319'' \
320' -- default decl --' \
321'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
322' -- hacks for opensp --' \
323'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
324'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
325'' \
326; do echo $l; done >> %1 \
327}
328
eea64748
ER
329# vim - "
330
4f044018
ER
331# minimum file size needed for compressed documents.
332# just smaller files than this get larger when compressed.
a88ae20f
ER
333# some stats:
334# - 0 byte file compressed was 25 bytes .gz
335# - 39 byte file was compressed as 57
336# - with test/test.spec@man 158 byte file was compressed also 158
337%_min_compress_bytes 159
4f044018 338
9c404149
AM
339#-----------------------------------------------------------------
340# find and gzip all files in %{_mandir} and %{infodir}
341#
342# Requires: xargs, find
343#
344#%no_install_post_compress_docs 1
345%__spec_install_post_compress_docs { \
53d5af13 346%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
4e10ec06 347 for i in /usr/share/man /usr/X11R6/man; do \
9c404149 348 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
4e10ec06 349 echo "Compress man pages: $i"; \
4f044018
ER
350 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
351 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
6375241c
ER
352 find $RPM_BUILD_ROOT$i -type l | while read a; do \
353 m=$(readlink $a); \
354 rm -f $a; \
355 echo .so ${m##*/} > $a; \
356 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
357 done; \
4f044018 358 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
9c404149
AM
359 fi; \
360 done; \
728ad671
JB
361 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
362 echo "Compress info pages: %{_infodir}"; \
363 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
364 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
365 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
4e10ec06 366 fi; \
53d5af13 367}; __spec_install_post_compress_docs } }
9c404149
AM
368
369#-----------------------------------------------------------------
370# Strip executable binaries and shared object files
371#
372# Requires: find, awk, strip, cut, xargs
373#
a2ad2754
JB
374# Special macros which affect this process:
375#%no_install_post_strip 1 # disable stripping at all
376#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
377#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
378#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
379#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
380#
9c404149 381%__spec_install_post_strip {%{!?debug: \
53d5af13 382%{!?no_install_post_strip:__spec_install_post_strip() { \
98a06bad 383if [ -d "$RPM_BUILD_ROOT" ]; then \
eea64748
ER
384 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
385 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
386 if [ "$modulelist" ]; then \
387 modulecount=$(echo "$modulelist" | wc -l); \
737fefdc 388 printf "Stripping %d kernel modules..." $modulecount; \
3df8db34
ER
389 echo "$modulelist" | xargs -l512 chmod u+w; \
390 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
391 echo "DONE"; \
392 fi; \
eea64748 393 fi; \
0ac49134 394 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
f89ccb5f
JB
395 if [ -n "$filelist" ]; then \
396 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
397 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
398 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
a2ad2754 399 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
f89ccb5f 400 if [ -n "$elfexelist" ]; then \
4d5370ac 401 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
f89ccb5f
JB
402 chmod u+w $elfexelist; \
403 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
404 echo "DONE"; \
405 fi; \
406 if [ -n "$elfsharedlist" ]; then \
4d5370ac 407 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
f89ccb5f
JB
408 chmod u+w $elfsharedlist; \
409 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
410 echo "DONE"; \
411 fi; \
412 if [ -n "$archiveslist" ]; then \
4d5370ac 413 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
f89ccb5f
JB
414 chmod u+w $archiveslist; \
415 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
416 echo "DONE"; \
417 fi; \
98a06bad 418 fi; \
0ac49134
ER
419 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
420 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
421 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
f89ccb5f 422 if [ -n "$filelist_all" ]; then \
4d5370ac 423 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
a2ad2754 424 chmod u+w $filelist_all; \
f89ccb5f 425 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
322f84b9 426 echo "DONE"; \
9c404149 427 fi; \
f89ccb5f 428 if [ -n "$filelist_unneeded" ]; then \
4d5370ac 429 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
a2ad2754 430 chmod u+w $filelist_unneeded; \
f89ccb5f 431 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
322f84b9 432 echo "DONE"; \
8f74418b 433 fi; \
f89ccb5f 434 if [ -n "$filelist_debug" ]; then \
4d5370ac 435 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
a2ad2754 436 chmod u+w $filelist_debug; \
f89ccb5f 437 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
322f84b9 438 echo "DONE"; \
9f0d4f36 439 fi; \
53d5af13 440fi; }; __spec_install_post_strip } } }
3241033b 441
fc5d7e20 442#-----------------------------------------------------------------
443# remove all RPATH from executable binaries and shared object files
444#
445# Requires: find, awk, cut, xargs, chrpath, uname
446#
a2ad2754
JB
447# Special macros which affect this process
448#%no_install_post_chrpath 1 # disable chrpath at all
449#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
450#
fc5d7e20 451%__spec_install_post_chrpath {%{!?debug: \
53d5af13 452%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
9f0d4f36 453if [ -d "$RPM_BUILD_ROOT" ]; then \
0ac49134 454 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
98a06bad 455 if [ -n "$files" ]; then \
d5517264 456 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
3401a2cd 457 fi; \
98a06bad 458 if [ -n "$objs" ]; then \
4d5370ac 459 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
98a06bad
ER
460 echo "$objs" | \
461 while read file; do \
462 rpath= ; \
463 chmod u+w "$file"; \
5541bf26 464 for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
eda6b510
AM
465 case $dir in \
466 '$ORIGIN' ) \
467 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
468 else rpath="$rpath:$dir" ; fi ; \
469 continue ; \
470 ;; \
471 esac ; \
f9abaddb
AM
472 newdir=$(readlink -m "$dir"); \
473 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
98a06bad
ER
474 case $dir in \
475 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
476 echo "remove-rpath: $dir in $file"; \
477 ;; \
478 * ) \
479 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
480 else rpath="$rpath:$dir" ; fi ; \
481 ;; \
482 esac ; \
483 done ; \
484 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
485 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
486 done; \
487 fi; \
53d5af13 488fi; }; __spec_install_post_chrpath } } }
3241033b 489
d366d7e0
AM
490#-----------------------------------------------------------------
491# Find all shared object files with unresolved symbols. Warn
492# and terminate if any found (termination can be turned off by define).
493#%no_install_post_check_so 1
494%__spec_install_post_check_so { \
495 __spec_install_post_check_so() { \
496 fail=0; \
497 printf "Searching for shared objects with unresolved symbols..."; \
34906a2d 498 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
7df9ddfc 499 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; exit(1); } } ' || fail=1 ; \
d366d7e0
AM
500 done ; \
501 echo " DONE"; \
2911e7af 502 %{!?no_install_post_check_so:[ $fail -eq 1 ] && exit 0 || exit 0;} \
d366d7e0
AM
503}; __spec_install_post_check_so }}
504
d72c185f 505#-----------------------------------------------------------------
ccb8ae8d 506# Find and gzip all kernel modules
507#
508# Requires: find
509#
fe6c4bdd 510#%no_install_post_compress_modules 1
ccb8ae8d 511%__spec_install_post_compress_modules { \
53d5af13 512%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
f3bfe4ac 513 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
f3bfe4ac 514 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
515 if [ "$q" ]; then \
516 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
517 echo "$q" | xargs -r %{__gzip} -9nf; \
518 echo "DONE"; \
519 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
520 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
521 fi; \
3241033b 522 fi; \
53d5af13 523}; __spec_install_post_compress_modules } }
9c404149 524
ef64802f
ER
525# Remove common Perl files we don't package
526%__spec_install_post_perl_clean {\
527%{!?no_install_post_perl_clean: \
528%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
529} }
530
83094b62 531#-----------------------------------------------------------------
0e4cb4dd 532# Update GConf2 schemas
83094b62 533#
534# Requires: GConf2
535#
46885239 536%gconf_schema_install() \
307ac6c9
ER
537 umask 022; \
538 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
539 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
f27cf2fd 540%{nil}
46885239 541
542%gconf_schema_uninstall() \
24336a54 543if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
3241033b 544 umask 022; \
24336a54
ER
545 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
546 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
f27cf2fd 547fi; \
f93109a0 548%{nil}
549
550#-----------------------------------------------------------------
551# Update desktop MIME database
c0a4caa0 552# requires: desktop-file-utils
c3bcd10e 553%update_desktop_database() {{ \
f93109a0 554 umask 022; \
fb59e475 555 /usr/bin/update-desktop-database -q; \
c00bf95c
MB
556};} \
557%{nil}
f93109a0 558
c3bcd10e
ER
559%update_desktop_database_post %update_desktop_database
560
561%update_desktop_database_postun() {{ \
f27cf2fd 562if [ "$1" = "0" ]; then \
c00bf95c 563 %update_desktop_database \
f27cf2fd 564fi; \
c00bf95c
MB
565};} \
566%{nil}
f93109a0 567
fb59e475 568#-----------------------------------------------------------------
569# Update shared MIME info database
570# requires: shared-mime-info
571#
c3bcd10e 572%update_mime_database() {{ \
fb59e475 573 umask 022; \
574 /usr/bin/update-mime-database %{_datadir}/mime; \
c00bf95c
MB
575};} \
576%{nil}
fb59e475 577
578#-----------------------------------------------------------------
579# Update icon cache
580# requires: gtk+
581#
c3bcd10e 582%update_icon_cache() {{ \
fb59e475 583 umask 022; \
072f4b80 584 /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
c00bf95c
MB
585};} \
586%{nil}
fb59e475 587
f93109a0 588#-----------------------------------------------------------------
589# Update scrollkeeper database
590# requires: scrollkeeper
591#
592%scrollkeeper_update_post() \
f93109a0 593 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 594%{nil}
f93109a0 595
596%scrollkeeper_update_postun() \
f27cf2fd 597if [ "$1" = "0" ]; then \
f93109a0 598 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 599fi; \
f93109a0 600%{nil}
601
9c404149
AM
602#-----------------------------------------------------------------
603# post %install sequence:
604# - autodeps exceptions
605# - compress all man and info pages,
606# - strip all ELF executables and ELF shared objects if not %debug.
8f74418b 607# - compress kernel modules if any
9c404149
AM
608
609###################################################################
610# Requires/Provides automation
3e202b06 611# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
338726a6 612#
2892b5df
JB
613%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
614%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
615%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
616%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
617%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
c94807f3 618
338726a6
JB
619#%_noautocompressdoc %{nil}
620#
8f74418b
MM
621%_missing_doc_files_terminate_build 1%{nil}
622%_unpackaged_files_terminate_build %{nil}
8781dc74 623# (X)emacs support
d77dcb61 624%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
c94807f3
ER
625%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
626%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
25043cd4 627
02b58f60
JK
628%__php_provides %{nil}
629%__php_requires %{nil}
630%__perl_provides %{nil}
631%__perl_requires %{nil}
fa3497cd 632%__mono_provides %{nil}
633%__mono_requires %{nil}
25043cd4
AF
634
635# Perl specific macro definitions.
c94807f3
ER
636%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
637%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
638%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
639%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
640%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
641%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
25043cd4 642
45c00b39 643# Ruby
c94807f3
ER
644%__ruby /usr/bin/ruby
645%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
646%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
647%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
648%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
649%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
650%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
651%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
751cfc9e 652%ruby_rdocdir /usr/share/rdoc
c94807f3 653%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
669604db
ER
654%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
655%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
45c00b39 656
7ccf7643 657%php_pear_dir /usr/share/pear
7813c433 658%php_data_dir /usr/share/php
c94807f3
ER
659%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
660%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
661%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
25043cd4 662
0c5d1b9b 663# extract php/zend api versions
c94807f3
ER
664%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
665%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
666%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
667%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
668%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
669%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
670%zend_zts %{expand:%%global zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%zend_zts
c1b2705c
ER
671
672# helper macro
f952c0f3 673%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
c1b2705c
ER
674
675# macros for public use
676# for php extensions (php-pecl)
68b68193 677%requires_php_extension %{__php_api_requires modules_api php_api_version} \
415f4a1a 678%{__php_api_requires zend_module_api} \
f952c0f3
ER
679%{__php_api_requires -v %php_major_version debug php_debug} \
680%{__php_api_requires -v %php_major_version thread-safety zend_zts}
68b68193 681
c1b2705c
ER
682# for zend extensions
683%requires_zend_extension %{__php_api_requires zend_module_api} \
68b68193 684%{__php_api_requires zend_extension_api} \
f952c0f3
ER
685%{__php_api_requires -v %php_major_version debug php_debug} \
686%{__php_api_requires -v %php_major_version thread-safety zend_zts}
c1b2705c 687
934c685f
ER
688# for php pdo modules (php-pecl-PDO_*)
689%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
690
6c3b8203
ER
691# for using PHP post scripts. for PHP >= 5.0
692%php_webserver_restart \
693[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
578e7794 694[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
ba1800dc
ER
695if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
696 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
697 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
698 %service -q php-fcgi restart \
699 fi \
700fi \
6c3b8203
ER
701%{nil}
702
703# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
704%php4_webserver_restart \
705[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
578e7794 706[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
ba1800dc
ER
707if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
708 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
709 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
710 %service -q php-fcgi restart \
711 fi \
712fi \
6c3b8203
ER
713%{nil}
714
578e9248 715# X.org helper macros
434ab5a2
ER
716%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
717%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
718
c94807f3
ER
719%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
720%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
721%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
722%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
723%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
578e9248 724
434ab5a2 725%requires_xorg_xserver_extension \
97486460
AM
726%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
727%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
728%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
729%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
434ab5a2
ER
730%{nil}
731
732%requires_xorg_xserver_xinput \
97486460
AM
733%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
734%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
735%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
736%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
434ab5a2
ER
737%{nil}
738
739%requires_xorg_xserver_font \
97486460
AM
740%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
741%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
742%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
743%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
434ab5a2
ER
744%{nil}
745
746%requires_xorg_xserver_videodrv \
97486460
AM
747%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
748%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
749%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
750%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
434ab5a2 751%{nil}
578e9248 752
25043cd4
AF
753# Python specific macro definitions.
754# python main version
2383a9da 755%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
25043cd4
AF
756
757# directories
2383a9da 758%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
3241033b 759%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
ef7ec0a8 760%py_scriptdir %{py_prefix}/share/python%{py_ver}
3241033b 761%py_incdir /usr/include/python%{py_ver}
7ccf7643 762%py_sitedir %{py_libdir}/site-packages
ef7ec0a8 763%py_sitescriptdir %{py_scriptdir}/site-packages
3241033b 764%py_dyndir %{py_libdir}/lib-dynload
25043cd4
AF
765
766# pure python modules compilation
3241033b 767%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4 768
3241033b 769%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4
AF
770
771# Software written in Python language require Python with main version
e63cd81d 772%pyrequires_eq() Requires: %1
25043cd4 773
f12c2314 774# Hardlink binary identical .pyc and .pyo files
f12c2314 775%__spec_install_post_py_hardlink {\
53d5af13 776%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
f35a1d62
ER
777local a b c=0 t=0; \
778if [ -d "$RPM_BUILD_ROOT" ]; then \
779 find "$RPM_BUILD_ROOT" -name '*.pyc' > __rpm_pyc; \
780 while read a; do \
781 b="${a%.pyc}.pyo"; \
782 if cmp -s "$a" "$b"; then \
783 ln -f "$a" "$b"; \
784 c=$((c + 1)); \
785 fi; \
786 t=$((t + 1)); \
787 done < __rpm_pyc; \
788 [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
789 rm -f __rpm_pyc; \
790fi; \
53d5af13 791}; __spec_install_post_py_hardlink } }
f12c2314 792
9227b3f9 793# remove python sources, so that check-files won't complain
f12c2314 794%py_postclean() \
0f82e280 795for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
820792a9 796 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
f12c2314
AF
797done \
798%{nil}
799
0fc5cff8 800# depmod macro
801%depmod() { \
f6148427 802umask 022; \
0fc5cff8 803if [ -e /boot/System.map-%1 ]; then \
3241033b 804 /sbin/depmod -a -F /boot/System.map-%1 %1; \
0fc5cff8 805else \
3241033b
ER
806 if [ -e /boot/System.map ]; then \
807 /sbin/depmod -a -F /boot/System.map %1; \
808 else \
809 /sbin/depmod -a %1; \
810 fi \
0fc5cff8 811fi; \
812}
813
2afc6e64 814# XMMS specific macros
c94807f3
ER
815%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
816%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
817%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
818%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
819%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
820%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
821%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
822%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
823%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
824%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
825
826%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')}%_target_base_arch
d1537778 827
848c0d68 828# user/group checking macros
829#
830# Usage:
831# %userremove myuser
832#
833%userremove /usr/lib/rpm/user_group.sh user del
834%groupremove /usr/lib/rpm/user_group.sh group del
835#
836# Usage:
837# if %usertestrm myuser; then
838# /usr/sbin/userdel -r myuser
839# Note:
840# use these macros only if you need to call userdel/groupdel with
841# a non-standard option or take an extra action; otherwise use the
842# %userremove/%groupremove macros
843#
844%usertestrm /usr/lib/rpm/user_group.sh user testrm
845%grouptestrm /usr/lib/rpm/user_group.sh group testrm
08d9b1f6
JK
846# user group membership management macros
847#
848# Usage:
849# %addusertogroup myuser agroup
850#
851%addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
72fcfcb3 852
853# banner support (useful in {pre,post}{,un} and triggers)
854#
855# Usage:
aa41c920 856# %banner name [-a] [-e] [-n] [-tn] <<EOF
72fcfcb3 857# the banner text, the banner text
aa41c920
ER
858# the banner text, and following line
859#EOF
860# You can use any form of here-document, <<'EOF' <<-EOT will do.
861# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
862#
72fcfcb3 863# -a - append to the banner
a8b9562a 864# -e - send to stderr instead of stdout
628754cb 865# -n - no show banner (overrides -t)
866# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
276a7b45
ER
867#
868# Tests:
869# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
870# rpm -E 'date | %banner -e banner' > m; sh -x m
871#
afb54f6c 872%banner(aent:) ( \
1b334fe4 873RPM_SCRIPTVERBOSITY=5 \
874[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
875if [ -x /usr/bin/banner.sh ]; then \
aa41c920 876 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1b334fe4 877else \
a8b9562a 878 CMD="cat%{-e: >&2}" \
1b334fe4 879fi \
276a7b45
ER
880eval $CMD %{?2:%2}%{?3: %3}) \
881%{nil}
628754cb 882
990bd03f 883# useradd/groupadd macros
4c73bc69 884# Author: Elan Ruusamäe <glen@pld-linux.org>
90627280
ER
885#
886# Usage:
887# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
888# [-g initial_group] [-G group[,...]] login
889#
890# -u uid. REQUIRED
891# -g gid/group. REQUIRED
892# -s defaults to /bin/false
893# -d defaults to /usr/share/empty
894# -c No default
895# -r is accepted but ignored (it's always set)
6bd4c218 896# -k skeleton dir. defaults to /usr/share/empty
90627280
ER
897# rpm specific flags
898# -P package name. defaults to %{name}
899#
90627280 900%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
9ba02ba9
ER
901%{!-u:%{error:useradd: Required argument -u missing}} \
902%{!-g:%{error:useradd: Required argument -g missing}} \
903%{!?1:%{error:useradd: Required parameter login missing}} \
90627280
ER
904if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
905 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
906 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
907 exit 1 \
908 fi \
909else \
910 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
911 /usr/sbin/useradd \\\
b5a7d552 912 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
90627280
ER
913 -u %{-u*} \\\
914 -r \\\
915 -d %{-d*}%{!-d:/usr/share/empty} \\\
916 -s %{-s*}%{!-s:/bin/false} \\\
840e7b00 917 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
90627280
ER
918 -g %{-g*} \\\
919 %{-M} \\\
920 %{-G:-G %{-G*}} \\\
1aac682a 921 %{expand:%{%{#}}} 1>&2 || exit $? \
bcf63b58 922 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
90627280
ER
923fi;
924
90627280
ER
925# Usage:
926# %groupadd [-P package] [-g gid] group
927#
928# -g gid. REQUIRED
929#
930# Sample:
931# %groupadd -P %{name}-base -g %{gid} %{name}
932
933%groupadd(g:P:rfo) \
9ba02ba9
ER
934%{!-g:%{error:groupadd: Required argument -g missing}} \
935%{!?1:%{error:groupadd: Required parameter group missing}} \
637962e6 936if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
90627280
ER
937 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
938 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
939 exit 1 \
940 fi \
941else \
942 echo "Adding group %{1} GID=%{-g*}." \
1aac682a 943 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
bcf63b58 944 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
90627280 945fi;
7cb77741 946
7c50f037 947# webapp macros
4c73bc69 948# Author: Elan Ruusamäe <glen@pld-linux.org>
35663282
ER
949#
950# The config is installed/removed inside trigger, this means that you can any
951# time install apache1/apache/lighttpd package and the configuration file is
fe6c4bdd 952# updated. if you don't need the config for various reason for specific
35663282
ER
953# webserver, just remove the symlink from config directory using webapp
954# program. the trigger will not recreate the symlink on upgrades. In other
955# words the config is linked to webserver config directory on first install of
956# PACKAGE or WEBSERVER.
957#
7c50f037
ER
958# Add package's webserver config to webserver webapps dir.
959# Usage:
df979130 960# %webapp_register WEBSERVER WEBAPP
35663282
ER
961#
962%webapp_register() \
963%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
964if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
965 /usr/sbin/webapp register %1 %2\
966fi\
694a8f2e 967# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
5d3a09a3 968if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
16897aea 969 %{expand:%service -q %%1 reload}\
35663282
ER
970fi\
971%{nil}
972
973# Remove package's config from webserver webapps dir.
35663282 974# Usage:
531c0efc
ER
975# %webapp_register [-f] WEBSERVER WEBAPP
976%webapp_unregister(f) \
35663282
ER
977%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
978# remove link if either of the packages are gone \
5d3a09a3 979if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
df979130 980 /usr/sbin/webapp unregister %1 %2\
16897aea 981 %{expand:%service -q %%1 reload}\
35663282
ER
982fi \
983%{nil}
984
462b26fa 985# service macro.
4c73bc69 986# Author: Elan Ruusamäe <glen@pld-linux.org>
462b26fa
ER
987#
988# calls usual service restart on package %post, but skips the restart if
989# administrator has disabled automatic service restarts in either global
990# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
991#
462b26fa 992# Usage:
7377b5ca 993# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
462b26fa 994#
a0bbe604 995# -q be silent when service isn't started (for scriplets restaring other package's services)
7377b5ca 996# -n NOOP mode, do not actually restart service
462b26fa 997#
7377b5ca
ER
998# Requirements:
999# BuildRequires: rpmbuild(macros) >= 1.268
1000# Requires: rc-scripts
1001# -n option:
1002# BuildRequires: rpmbuild(macros) >= 1.450
1003%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
6aedae62
ER
1004
1005
f9aa75bf
ER
1006# Java macros. based on jpackage macros.java
1007#
1008# Root directory where all Java VMs/SDK/JREs are installed.
2d4659a1 1009%_jvmdir %{_libdir}/jvm
f9aa75bf
ER
1010
1011# Root directory where all Java VMs/SDK/JREs expose their jars
2d4659a1 1012%_jvmjardir %{_libdir}/jvm-exports
f9aa75bf
ER
1013
1014# Root directory for all Java VM/SDK/JRE's private things.
1015%_jvmprivdir %{_libdir}/jvm-private
1016
1017# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
2d4659a1 1018%_jvmlibdir %{_libdir}/jvm
f9aa75bf
ER
1019
1020# Root directory for all architecture independent parts of Java VM/SDK/JRE's
1021%_jvmdatadir %{_datadir}/jvm
1022
1023# Root directory for all configurations parts of Java VM/SDK/JRE's
1024%_jvmsysconfdir %{_sysconfdir}/jvm
1025
1026# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
f5ed4276 1027%_jvmcommonlibdir %{_libdir}/jvm-common
f9aa75bf
ER
1028
1029# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
f5ed4276 1030%_jvmcommondatadir %{_datadir}/jvm-common
f9aa75bf
ER
1031
1032# Root directory for all common configurations parts of Java VM/SDK/JRE's
f5ed4276 1033%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
f9aa75bf
ER
1034
1035# Directory where arch-specific (JNI) version-independent jars are installed.
2d4659a1 1036%_jnidir %{_libdir}/java
f9aa75bf 1037
c94807f3 1038%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})}%java_home
6aedae62 1039
a9254650 1040%ant JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
fe6c4bdd 1041%jar %{java_home}/bin/jar
c94807f3 1042%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)}%java
fe6c4bdd
ER
1043%javac %{java_home}/bin/javac
1044%javadoc %{java_home}/bin/javadoc
6aedae62 1045
fe6c4bdd 1046%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
6aedae62
ER
1047
1048%jpackage_script() \
3ca65b87
ER
1049install -d $RPM_BUILD_ROOT%{_bindir}\
1050cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
6aedae62
ER
1051#!/bin/sh\
1052#\
1053# %{name} script\
1054# JPackage Project <http://www.jpackage.org/>\
1055\
1056# Source functions library\
1057. %{_javadir}-utils/java-functions\
1058\
1059# Source system prefs\
3ca65b87 1060if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
fe6c4bdd 1061 . %{_sysconfdir}/java/%{name}.conf\
6aedae62
ER
1062fi\
1063\
1064# Source user prefs\
3ca65b87
ER
1065if [ -f $HOME/.%{name}rc ]; then\
1066 . $HOME/.%{name}rc\
6aedae62
ER
1067fi\
1068\
1069# Configuration\
1070MAIN_CLASS=%1\
1071BASE_FLAGS=%2\
1072BASE_OPTIONS=%3\
3ca65b87 1073BASE_JARS="%(echo %4 | tr ':' ' ')"\
6aedae62
ER
1074\
1075# Set parameters\
1076set_jvm\
3ca65b87
ER
1077set_classpath $BASE_JARS\
1078set_flags $BASE_FLAGS\
1079set_options $BASE_OPTIONS\
6aedae62
ER
1080\
1081# Let's start\
3ca65b87 1082run "$@"\
6aedae62
ER
1083EOF
1084
06f11871
ER
1085# jpackage 1.7
1086# Directory for maven depmaps
1087#
1088%_mavendepmapdir /etc/maven
1089%_mavendepmapfragdir /etc/maven/fragments
1090
1091#
1092# add_to_depmap adds an entry to the depmap. The arguments are:
1093#
1094# %1 the original groupid
1095# %2 the original artifact id
1096# %3 the version
1097# %4 the new groupid
1098# %5 the new artifactid
1099#
1100
1101%add_to_maven_depmap() \
1102install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1103cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1104<dependency>\
1105 <maven>\
1106 <groupId>%1</groupId>\
1107 <artifactId>%2</artifactId>\
1108 <version>%3</version>\
1109 </maven>\
1110 <jpp>\
1111 <groupId>%4</groupId>\
1112 <artifactId>%5</artifactId>\
1113 <version>%3</version>\
1114 </jpp>\
1115</dependency>\
1116\
1117EOF\
1118%{nil}
1119
1120#==============================================================================
1121#
1122# update_maven_depmap updates the main maven depmap
1123#
1124%update_maven_depmap() \
1125echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1126if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1127cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1128fi\
1129echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1130
1131
59d3ebe9 1132# PEAR install macros
4c73bc69 1133# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1134#
1135# Usage:
f7ecf326 1136# %%pear_package_setup ...
dfce8b19 1137#
59d3ebe9 1138# -a # - also unpack SOURCE#. for PEAR bootstrapping
dfce8b19 1139# -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
59d3ebe9 1140# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
f7ecf326
ER
1141# -D - pass -D to %setup (so the build dir is not removed)
1142# -c - register channel from local channel.xml file
dfce8b19
ER
1143#
1144# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1145# destination hierarchy. you should copy the tree to buildroot after
1146# patching/reorganizing with %%pear_package_install.
1147#
1148# additionally BUILDROOT is stripped from files and files are converted to UNIX
1149# line endings.
1150#
1151# the pear install process output is recorded to install.log, you should put it
8763f51e 1152# to %%doc for later debug or just for information.
dfce8b19
ER
1153#
1154# additionally additional-packages.txt is produced if it was detected that the
1155# package has optional dependencies. the file format is suitable of displaying
1156# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1157# automatically added for this file.
59d3ebe9
ER
1158
1159
1160# records install.log and transforms PEAR names to PLD Linux rpm package names.
1161%__pear_install_log \
1162tee install.log \
1163# make post message of optional packages \
f64d1bb2 1164grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,;s,^channel://.*/,,' > optional-packages.txt \
59d3ebe9
ER
1165if [ -s optional-packages.txt ]; then \
1166 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1167else \
1168 rm -f optional-packages.txt \
1169fi \
1170%{nil}
1171
1172# command invoking pear cli
1173%__pear /usr/bin/pear
1174
67a089ff 1175%pear_install(a:n:zD) \
59d3ebe9 1176%__pear \\\
f7ecf326 1177 -c %{builddir}/pearrc \\\
dfce8b19 1178 -d doc_dir=/docs \\\
f7ecf326
ER
1179 -d temp_dir=/tmp \\\
1180 -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
dfce8b19
ER
1181 -d bin_dir=%{_bindir} \\\
1182 -d data_dir=%{php_pear_dir}/data \\\
1183 -d test_dir=%{php_pear_dir}/tests \\\
1184 install \\\
59d3ebe9 1185 --packagingroot=%{builddir} \\\
dfce8b19
ER
1186 --offline \\\
1187 --nodeps \\\
1188 %{-f:--force} \\\
67a089ff 1189 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
b872fad7 1190 %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
67a089ff
ER
1191%{nil}
1192
1193# The main macro.
1194# using this macro will append optional-packages.txt to the nocompressdoc list
1195# as it's displayed to user after package install. and adding additional gzip
1196# dep is just waste ;)
f7ecf326 1197%pear_package_setup(a:n:zDc:) \
67a089ff
ER
1198%define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1199%define builddir %{_builddir}/%{srcdir} \
1200%setup -q -c -T %{-D:-D} -n %{srcdir} \
1201%{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1202%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
f7ecf326 1203%{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
67a089ff 1204%pear_install \
59d3ebe9
ER
1205%{-z:cd ..} \
1206cat %{-z:$_N/}.install.log | %__pear_install_log \
1207\
dfce8b19 1208# undos sources \
2a80e4cf 1209find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
dfce8b19
ER
1210%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1211%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1212%{nil}
1213
7bef60e8 1214# Copies exctracted PEAR package structure and PEAR registry to buildroot.
4c73bc69 1215# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1216%pear_package_install() \
1217cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1218find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1219# help the developer out a little: \
1220if [ -f _noautoreq ]; then \
1221 echo "AutoReqdep detected:" \
1222 echo "_noautoreq $(cat _noautoreq)" \
1223fi \
1224%{nil}
1225
0d5dd00c
ER
1226
1227# Register OpenLDAP schema.
4c73bc69 1228# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1229#
1230# Usage:
1231# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1232#
1233# -d specify dependant schemas, separated by comma
1234#
1235%openldap_schema_register(d:) \
1236for schema in %*; do \
1237 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1238 %{__sed} -i -e " \
1239 /^include.*local.schema/{ \
1240 iinclude\\t $schema\
1241 } \
1242 " /etc/openldap/slapd.conf \
1243 fi \
1244done \
1245# enable dependant schemas \
1246if [ "%{-d*}" ]; then \
1247 %{__sed} -i -e ' \
1248 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1249 s/^#// \
1250 }' /etc/openldap/slapd.conf \
1251fi \
1252%{nil}
1253
1254# Unregister OpenLDAP schema.
4c73bc69 1255# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1256#
1257# Usage:
1258# %%openldap_schema_unregister %{schemadir}/horde.schema
1259#
1260%openldap_schema_unregister() \
1261for schema in %*; do \
1262 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1263 %{__sed} -i -e " \
1264 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1265 # for symmetry it would be nice if we disable enabled schemas in post, \
1266 # but we really can not do that, it would break something else. \
1267 " /etc/openldap/slapd.conf \
1268 fi \
1269done \
1270%{nil}
1271
b0bc2936 1272%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
d834e0a1 1273
dcc6baf7 1274
1275# Build modules for kernels 2.6
1276# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1277#
1278# Usage:
aa559e46 1279# %build_kernel_modules -m <modules> -C <directory>
dcc6baf7 1280#
1281# remember that proper Makefile is still required
1282# Options:
990bd03f 1283# -m <modules> (required) -- comma-separated list of modules to save,
dcc6baf7 1284# without .ko extension, may be placed in subdirectory
aa559e46 1285# -C <directory> -- change to <directory> before doing anything
dcc6baf7 1286# -p <arg>, -P <arg> -- arguments passeed to make scripts
5a81d83e 1287# -c -- do not execute make clean
dcc6baf7 1288# <additional arguments> -- all additional arguments will be passed to
1289# make modules
1290#
1291# Additional patching supported via here document. Try:
1292# %build_kernel_modules -m module <<'EOF'
1293# your patch script here
1294# EOF
1295# Don't use it unless patching depends on config options.
1296
1297# Developer note: don't touch it unless you know how to handle '\'.
1298# - \ in script expands to nothing
1299# - \\\ in script expands to \
566398b4 1300# - \\\ inside definition expands to nothing
dcc6baf7 1301# - \\\\\\\ inside definition expands to \
1302# - in last line \ has to touch arguments so arguments passing
1303# in new lines (using \) will be supported
1304
5a81d83e 1305%build_kernel_modules(p:P:m:C:c) \
dcc6baf7 1306%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1307 \
1308%define Opts \\\\\\\
1309%if "%{_target_base_arch}" != "%{_arch}" \\\
1310 %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
88608ef7 1311 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
dcc6baf7 1312 %else \\\
1313 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1314 %endif \\\
1315%else \\\
88608ef7 1316 CC="%{kgcc}" \\\
dcc6baf7 1317%endif \
88608ef7 1318%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
dcc6baf7 1319 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1320 \
e364bc26 1321%{?-C:cd %{-C*}} \
dcc6baf7 1322compile() { \
ba9de9b2
ER
1323 local L="<" PATCH_SH; \
1324 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
dcc6baf7 1325 set -e -x \
730239f9 1326 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1327 \
730239f9 1328for cfg in ${cfgs:-dist}; do \
dcc6baf7 1329 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1330 \
c546f6fb 1331 rm -rf o \
68cfe9d9 1332 install -d o/include/linux o/arch/powerpc/lib \
dcc6baf7 1333 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1334 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
1335 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1336 \
1337 set +x \
1338 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1339 set -x \
1340 \
c768535c 1341 %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?) \
dcc6baf7 1342 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1343 %{-p*} %{-P*} \\\
1344 %{MakeOpts} \
1345 %else \
1346 install -d o/include/config \
1347 touch o/include/config/MARKER \
588f1b0b 1348 ln -sf %{_kernelsrcdir}/include/config/auto-$cfg.conf o/include/config/auto.conf \
dcc6baf7 1349 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1350 %endif \
1351 \
5a81d83e 1352 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
dcc6baf7 1353 RCS_FIND_IGNORE="-name '*.ko' -o" \\\
f635907b 1354 ${1+"$@"} \\\
5a81d83e 1355 M=$PWD %{MakeOpts}} \
f635907b 1356 \
dcc6baf7 1357 %{__make} -C %{_kernelsrcdir} modules \\\
1358 ${1+"$@"} \\\
1359 M=$PWD %{MakeOpts} \
1360 \
1361 for MODULE in {%{-m*},}; do \
1362 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1363 done \
1364done \
aa559e46 1365%{?-C:cd -} \
dcc6baf7 1366} \
1367compile %{*}\
1368%{nil}
1369
1370
1371# Install kernel modules built by %build_kernel_modules
1372# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1373#
1374# Usage:
1375# %install_kernel_modules -m <modules> -d <directory>
1376#
1377# Options:
990bd03f 1378# -m <modules> (required) -- comma-separated list of modules to install,
dcc6baf7 1379# without .ko extension, may be placed in subdirectory
1380# -d <directory> (required) -- in what subdirectory modules should be
1381# installed (eg. misc, kernel/drivers/net)
1382# -s <suffix> -- suffix to use when installing modules, useful when module
1383# with same name exists in kernel already
1384# -n <file> -- name of modprobe config file to use (without .conf extension)
00395cf1 1385# for defining aliases, only useful with -s
dcc6baf7 1386
1387%install_kernel_modules(m:d:s:n:) \
1388%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1389%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1390%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1391 \
1392%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1393%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
412786d1 1394 \
730239f9 1395local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1396 \
1397for MODULE in {%{-m*},}; do \
1398 [ -n "${MODULE}" ] || continue \
730239f9
ER
1399 for cfg in ${cfgs:-dist}; do \
1400 [ "$cfg" = smp ] && suf=smp || suf= \
1401 MNAME=${MODULE##*/} \
1402 install -D ${MODULE}-$cfg.ko \\\
1403 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
b9460afb 1404 %{?-s:install -d %{ModprobeD}$suf \
730239f9
ER
1405 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1406 >> %{ModprobeD}$suf/%{-n*}.conf} \
1407 done \
dcc6baf7 1408done \
1409%{nil}
1410
fa65356c 1411# patchset macros
4c73bc69 1412# Author: Elan Ruusamäe <glen@pld-linux.org>
fa65356c
ER
1413#
1414# Usage:
1415# %patchset_source -f <seq(1) format> <start> [<end>]
1416# %patchset_patch <start> [<end>]
1417#
1418# If <end> is omited, it is assumed to be <start>.
1419#
1420# For example in preamble:
1421# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1422# and in %prep:
1423# %patchset_patch 33 44
1424
1425# generate SourceX urls from range START STOP
1426# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1427# The sources start from 10000
e91610db 1428%patchset_source(f:b:) %(
44f733ef 1429 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1430 start=$(expr $base + %1);
1431 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1432 # we need to call seq twice as it doesn't allow two formats
1433 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1434 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1435 paste %{tmpdir}/__ps{1,2};
1436 rm -f %{tmpdir}/__ps{1,2};
962f9ecf
ER
1437) \
1438%{nil}
fa65356c
ER
1439
1440# apply sources from %patchset_source
1441# -p specify -pX for %patch line
1442# -b base offset: defaults to 10000
1443%patchset_patch(f:p:b:) %(
44f733ef 1444 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1445 start=$(expr $base + %1);
1446 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1447 echo ": patchset_patch %1%{?2: to %2}";
1448 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
962f9ecf
ER
1449) \
1450%{nil}
fa65356c 1451
5730b44b 1452# browser plugins v2
4c73bc69 1453# Author: Elan Ruusamäe <glen@pld-linux.org>
5730b44b
ER
1454#
1455# Usage:
1456# %browser_plugins_add_browser <name> -p <plugindir>
1457#
1458# <name> (required) -- name of the browser. usually %{name}.
1459# -p <plugindir> (required) -- in what directory browser searches for its plugins.
02ebf70f
ER
1460# -b -- default blacklists
1461# -a <arch> override arch
5730b44b
ER
1462#
1463# Example:
1464# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1465
1466%_browserpluginsconfdir /etc/browser-plugins
5e19a4dc 1467%_browserpluginsdir %{_libdir}/browser-plugins
5730b44b
ER
1468%update_browser_plugins /usr/sbin/update-browser-plugins || :
1469
02ebf70f 1470%browser_plugins_add_browser(p:b:a:) \
9efd458e 1471 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
5730b44b 1472 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
02ebf70f
ER
1473 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1474 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
5730b44b
ER
1475 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1476 %{-b:cat >> $blacklist_file %{-b*}} \
1477%{nil}
1478
ad17b654
ER
1479# Helper for LUA.
1480# split string separated by space into quoted list
1481#
4c73bc69 1482# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1483#
1484# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1485%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1486
1487# adjust /etc/shells by adding and removing shells from there
4c73bc69 1488# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1489#
1490# Usage:
d9b789d9
ER
1491# %post -p <lua>
1492# %lua_add_etc_shells /bin/sh /bin/pdksh
ad17b654 1493#
d9b789d9
ER
1494# %preun -p <lua>
1495# if arg[2] == 0 then
1496# %lua_remove_etc_shells /bin/bash /bin/rbash
1497# end
7377b5ca
ER
1498#
1499# Requirements:
d9b789d9
ER
1500# BuildRequires: rpmbuild(macros) >= 1.462
1501#
ad17b654 1502
d9b789d9 1503%lua_add_etc_shells() \
ad17b654
ER
1504t = {}\
1505f = io.open("/etc/shells", "r")\
1506if f then\
1507 for l in f:lines() do t[l]=l; end\
1508 f:close()\
1509end\
1510for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1511 if not t[s] then\
b8c0bc18 1512 print("Adding "..s.." to /etc/shells")\
ad17b654
ER
1513 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1514 end\
1515end\
1516%{nil}
1517
d9b789d9
ER
1518%lua_remove_etc_shells() \
1519t = {}\
1520f = io.open("/etc/shells", "r")\
1521if f then\
1522 for l in f:lines() do t[l]=l; end\
1523 f:close()\
1524end\
1525for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1526 print("Removing "..l.." from /etc/shells")\
1527 t[l] = nil\
1528end\
1529s=""\
1530for _, l in pairs(t) do\
1531 s=s..l.."\\n"\
1532end\
1533io.open("/etc/shells", "w"):write(s)\
1534%{nil}
1535
1536# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1537#
1538# Author: Elan Ruusamäe <glen@pld-linux.org>
1539#
1540# Usage:
1541# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1542# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1543#
1544# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1545#
1546# Requirements:
1547# BuildRequires: rpmbuild(macros) >= 1.429
1548#
1549%add_etc_shells(p) %{-p:<lua>}\
1550%{expand:%%lua_add_etc_shells %*}\
1551%{nil}
1552
ad17b654 1553%remove_etc_shells(p) %{-p:<lua>}\
b8c0bc18 1554%{-p:if arg[2] == 0 then}\
d9b789d9 1555%{expand:%%lua_remove_etc_shells %*}\
750e19f4 1556%{-p:end} \
ad17b654
ER
1557%{nil}
1558
75bd6249
ER
1559# Check syntax for Python files
1560#
1561# Author: Elan Ruusamäe <glen@pld-linux.org>
1562# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1563#
1564# Usage:
1565# %py_lint src
1566#
1567# Requirements:
1568# BuildRequires: python
1569# BuildRequires: rpmbuild(macros) >= 1.469
1570
1571%py_lint() \
1572__py_lint() { \
1573find "$@" -type f -name '*.py' | python -c ' \
1574import sys \
1575import compiler \
1576\
1577err = 0\
1578for f in sys.stdin: \
1579 fd = open(f.strip()) \
1580 c = fd.read() \
1581 fd.close() \
1582 try: \
1583 compiler.parse(c) \
1584 except SyntaxError, e: \
1585 print "py_lint: %s: %s" % (f.strip(), e) \
1586 err = err + 1\
1587\
1588if err: \
1589 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1590 sys.exit(1) \
1591else: \
1592 print >> sys.stderr, "py_lint: Found no syntax errors." \
1593' \
1594}; __py_lint %* \
1595%{nil}
1596
59d3ebe9 1597# vim:ts=4 sw=4 noet syn=spec
This page took 0.512402 seconds and 4 git commands to generate.